//+------------------------------------------------------------------+
//|                                       Daily Range Calculator.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      "Data window & extra Periods by cja"
#property copyright "Copyright  2006, Ogeima"
#property link      "ph_bresson@yahoo.com"

#property indicator_separate_window

//---- input parameters

   extern int  First_Avg  = 5;
   extern int  Second_Avg = 10;
   extern int  Third_Avg  = 20;

// buffers

   double RAvgBuffer[];

// variables

   int    nDigits;

   int i    = 0;
   int R1   = 0;
   int R5   = 0;
   int R10  = 0;
   int R20  = 0;
   int RAvg = 0;
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

   int init()
   {

// indicators

   IndicatorShortName ("TSR");
   SetIndexBuffer     (0,RAvgBuffer);
   SetIndexLabel      (0,"RAvg");


   if (Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD" || Symbol()=="USDMXN") nDigits = 2;
   if (Symbol()=="GBPUSD" || Symbol()=="EURUSD" || Symbol()=="NZDUSD" || Symbol()=="USDCHF"  ||
      Symbol()=="USDCAD" || Symbol()=="AUDUSD" || Symbol()=="EURUSD" || Symbol()=="EURCHF"  || Symbol()=="EURGBP" || 
      Symbol()=="EURCAD" || Symbol()=="EURAUD" )nDigits = 4;

   return(0);
   }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

   int deinit()
   {

   return(0);
   }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

   int start()
   {

//   int      R1=0,R5=0,R10=0,R20=0,RAvg=0;
//   int      i=0;

   R1 = (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   
   for(i=1;i <= First_Avg;i++)
   R5 = R5 + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      
   for(i=1;i <= Second_Avg;i++)
   R10 = R10 + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
      
   for(i=1;i <= Third_Avg;i++)
   R20 = R20 + (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   
   R5   = (R5/First_Avg);
   R10  = (R10/Second_Avg);
   R20  = (R20/Third_Avg);
   RAvg = (R1+R5+R10+R20)/4;
   
   RAvgBuffer[i] = RAvg;

   string P=Period();
   
   ObjectCreate("TSR", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR",StringSubstr(Symbol(),0),12, "Arial Bold", CadetBlue);
   ObjectSet("TSR", OBJPROP_CORNER, 0);
   ObjectSet("TSR", OBJPROP_XDISTANCE, 25);
   ObjectSet("TSR", OBJPROP_YDISTANCE, 2);
   ObjectCreate("TSR1", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR1",StringSubstr(P,0),12, "Arial Bold", CadetBlue);
   ObjectSet("TSR1", OBJPROP_CORNER, 0);
   ObjectSet("TSR1", OBJPROP_XDISTANCE, 114);
   ObjectSet("TSR1", OBJPROP_YDISTANCE, 2);
        
   ObjectCreate("TSR2", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR2","Average Daily Range:", 10, "Arial Bold", CadetBlue);
   ObjectSet("TSR2", OBJPROP_CORNER, 0);
   ObjectSet("TSR2", OBJPROP_XDISTANCE, 150);
   ObjectSet("TSR2", OBJPROP_YDISTANCE, 2);
   ObjectCreate("TSR3", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR3",DoubleToStr(RAvg ,0),12, "Arial Bold", Orange);
   ObjectSet("TSR3", OBJPROP_CORNER, 0);
   ObjectSet("TSR3", OBJPROP_XDISTANCE, 300);
   ObjectSet("TSR3", OBJPROP_YDISTANCE, 2);
        
   ObjectCreate("TSR4", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR4","Prev 1 Day Range:", 10, "Arial ", LightSteelBlue);
   ObjectSet("TSR4", OBJPROP_CORNER, 0);
   ObjectSet("TSR4", OBJPROP_XDISTANCE, 25);
   ObjectSet("TSR4", OBJPROP_YDISTANCE, 20);
   ObjectCreate("TSR5", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR5",DoubleToStr(R1,0),12, "Arial Bold", Orange);
   ObjectSet("TSR5", OBJPROP_CORNER, 0);
   ObjectSet("TSR5", OBJPROP_XDISTANCE, 170);
   ObjectSet("TSR5", OBJPROP_YDISTANCE, 20);
        
   ObjectCreate("TSR6", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR6","Prev "+First_Avg+" Days Range:", 10, "Arial ", LightSteelBlue);
   ObjectSet("TSR6", OBJPROP_CORNER, 0);
   ObjectSet("TSR6", OBJPROP_XDISTANCE, 25);
   ObjectSet("TSR6", OBJPROP_YDISTANCE, 35);
   ObjectCreate("TSR7", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR7",DoubleToStr(R5,0),12, "Arial Bold", Orange);
   ObjectSet("TSR7", OBJPROP_CORNER, 0);
   ObjectSet("TSR7", OBJPROP_XDISTANCE, 170);
   ObjectSet("TSR7", OBJPROP_YDISTANCE, 35);
        
   ObjectCreate("TSR8", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR8","Prev "+Second_Avg+" Days Range:", 10, "Arial ", LightSteelBlue);
   ObjectSet("TSR8", OBJPROP_CORNER, 0);
   ObjectSet("TSR8", OBJPROP_XDISTANCE, 220);
   ObjectSet("TSR8", OBJPROP_YDISTANCE, 20);
   ObjectCreate("TSR9", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR9",DoubleToStr(R10,0),12, "Arial Bold", Orange);
   ObjectSet("TSR9", OBJPROP_CORNER, 0);
   ObjectSet("TSR9", OBJPROP_XDISTANCE, 365);
   ObjectSet("TSR9", OBJPROP_YDISTANCE, 20);
        
   ObjectCreate("TSR10", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR10","Prev "+Third_Avg+" Days Range:", 10, "Arial ", LightSteelBlue);
   ObjectSet("TSR10", OBJPROP_CORNER, 0);
   ObjectSet("TSR10", OBJPROP_XDISTANCE, 220);
   ObjectSet("TSR10", OBJPROP_YDISTANCE, 35);
   ObjectCreate("TSR11", OBJ_LABEL, WindowFind("TSR"), 0, 0);
   ObjectSetText("TSR11",DoubleToStr(R20,0),12, "Arial Bold", Orange);
   ObjectSet("TSR11", OBJPROP_CORNER, 0);
   ObjectSet("TSR11", OBJPROP_XDISTANCE, 365);
   ObjectSet("TSR11", OBJPROP_YDISTANCE, 35);

   return(0);
   }

//+------------------------------------------------------------------+